<?php
 
//creates connection to database using PDO
 function openDBConnection()
{
       $dsn = 'mysql:host=localhost;dbname=s_jegunn';
       $username = 's_jegunn';
       $password='s_jegunn';
       
       try{
           $db = new PDO($dsn, $username, $password);
           
       } catch (Exception $e) {
           $errorMessage = $e->getMessage();
            include '../view/errorPage.php';
           die;
       }
       return $db;
}
//gets information about one song in database using trackID
function getSong($trackID){
    try
    {
        $db = openDBConnection();
        $query = "select * from music
                  WHERE TrackID = :trackID ";
        $statement = $db->prepare($query);
        $statement->bindValue(':trackID', $trackID);
        $statement->execute();
        $results = $statement->fetch();
        $results['songImagePath'] = getSongImage($trackID);
        return $results;
    }
    catch(PDOException $e){
      $errorMessage = $e->getMessage();
       include '../view/errorPage.php';
       die;
    }
}
//returns all songs in database
function getAllSongs(){
    try
    {
        $db = openDBConnection();
        $query = "select * from music ORDER BY Title";
        $statement = $db->prepare($query);
        $statement->execute();
        $results = $statement->fetchAll();
        $statement->closeCursor();
        return $results;
    }
    catch(PDOException $e){
      $errorMessage = $e->getMessage();
       include '../view/errorPage.php';
       die;
    }
}
//return filepath for track art
 function getSongImage($trackID){
     $songImageDirectory = '../images/songImages';
     return "$songImageDirectory/$trackID.jpg";
    
 }
 function checkSongImagePath($trackID) {
		$trackFilePath = getSongImage($trackID);
		if (is_file($trackFilePath)) {
			return $trackFilePath;
		} else {
			return "";
		}
	}
function saveSongImageFile($trackID, $tempImageFilePath) {
		if ($tempImageFilePath != "") {
			$newImagePath = getSongImage($trackID);
			if (move_uploaded_file($tempImageFilePath, $newImagePath) == FALSE) {
				$errorMessage = "Unable to move the image file.";
				include '../view/errorPage.php';
			}
		}
	}
//saves email to members.csv
function saveMemberInfo($email){
    
    $file=fopen('../datafiles/members.csv', 'ab');
        fputcsv($file,
        array($email));
        fclose($file);
}
//takes $genre and uses that to filter query when user requests songs by specific genre using links on seach page
function getTrack($genre) {
		try {
			$db = openDBConnection();
			$query = "select * from music WHERE Genre = :genre order by Title";
			$statement = $db->prepare($query);
                        $statement->bindValue(':genre', $genre);
			$statement->execute();
			$results = $statement->fetchAll();
			$statement->closeCursor();
			return $results;           // Assoc Array of Rows
		} catch (PDOException $e) {
			$errorMessage = $e->getMessage();
			include '../view/errorPage.php';
			die;
		}		
	}
        //takes string from general search and looks for similar results in string fields in data
function getByGeneralSearch($criteria) {
		try {
			$db = openDBConnection();
			$query = "SELECT *
                                        FROM music
                                        WHERE Title LIKE :criteria OR 
                                        Artist LIKE :criteria OR
                                        Genre LIKE :criteria OR
                                        Album LIKE :criteria
                                        ORDER BY Title";
			$statement = $db->prepare($query);
			$statement->bindValue(':criteria', "%$criteria%");
			$statement->execute();
			$results = $statement->fetchAll();
			$statement->closeCursor();
			return $results;           // Assoc Array of Rows
		} catch (PDOException $e) {
			$errorMessage = $e->getMessage();
			include '../view/errorPage.php';
			die;
		}		
	}
        //determines how music tracks need to be sorted using passed in case and then executes query to server
function getSortedTracks($case){
    
        try
        {
            $db = openDBConnection();
             if($case == 'Recent'){
             $query = "select * from music ORDER BY Upload_Date DESC";
             }
             else if($case == 'Oldest'){
             $query = "select * from music ORDER BY Upload_Date";
              }
            $statement = $db->prepare($query);
            $statement->execute();
            $results = $statement->fetchAll();
            return $results;
        }
        catch(PDOException $e){
          $errorMessage = $e->getMessage();
           include '../view/errorPage.php';
           die;
        }
}

function insertSong ($title, $artist, $album, $genre, $link, $tracklength, $releasedate, $uploaddate,$isvideo, $tempImageFilePath) {
		$db = openDBConnection();
		$query = 'INSERT INTO music(Title, Artist, Album, Genre, Link, Track_Length, Release_Date, Upload_Date, Is_Video)
			VALUES (:Title, :Artist, :Album, :Genre, :Link, :Track_Length, :Release_Date, :Upload_Date, :Is_Video)';
		$statement = $db->prepare($query);

		$statement->bindValue(':Title', $title);
		$statement->bindValue(':Artist', $artist);
		$statement->bindValue(':Album', $album);
		$statement->bindValue(':Genre', $genre);
		$statement->bindValue(':Link', $link);
		$statement->bindValue(':Track_Length', $tracklength);
                $statement->bindValue(':Release_Date', toMySQLDate($releasedate));
                $statement->bindValue(':Upload_Date', toMySQLDate($uploaddate));
                $statement->bindValue(':Is_Video', $isvideo);
		

		$success = $statement->execute();
		$statement->closeCursor();

		if ($success) {
                    saveSongImageFile($db->lastInsertId(), $tempImageFilePath);
			return $db->lastInsertId(); // Get generated BeerID
		} else {
			logSQLError($statement->errorInfo());  // Log error to debug
		}		
	}
    function logSQLError($errorInfo) {
		$errorMessage = $errorInfo[2];
		include '../view/errorPage.php';
	}
        
        function deleteOneSong($trackID){
		$db = openDBConnection();

		$query = 'DELETE FROM music
                          WHERE TrackID =  :TrackID';

		$statement = $db->prepare($query);
		$statement->bindValue(':TrackID', $trackID);

		$success = $statement->execute();
		$statement->closeCursor();

		if ($success) {
                    deleteSongImageFile($trackID);
			return $statement->rowCount(); // Number of rows affected
		} else {
			logSQLError($statement->errorInfo());  // Log error 
		}		
	}
        function deleteSongImageFile($trackID) {
		$imageFilePath = getSongImage($trackID);
		if ($imageFilePath != "") {
			if (unlink($imageFilePath) == FALSE) {
				$errorMessage = "Unable to delete image file at $imageFilePath.";
				include '../view/errorPage.php';
			}
		}
	}
        function updateSong($trackID,$stitle, $artist, $album, $genre, $link,  $length, $releasedate,$uploaddate, $isvideo,$tempImageFilePath, $deleteImage ) {
		$db = openDBConnection();
		$query = 'UPDATE music  SET Title = :Title, Artist = :Artist, 
					Album = :Album, Genre = :Genre, Link = :Link,
					Track_Length = :Length, Release_Date = :ReleaseDate, 
                                        Upload_Date = :UploadDate, Is_Video = :Is_Video
                                        WHERE TrackID =  :TrackID';
		$statement = $db->prepare($query);
		$statement->bindValue(':TrackID', $trackID);
		$statement->bindValue(':Title', $stitle);
		$statement->bindValue(':Artist', $artist);
		$statement->bindValue(':Album', $album);
		$statement->bindValue(':Genre', $genre);
		$statement->bindValue(':Link', $link);
                $statement->bindValue(':Length', $length);
		$statement->bindValue(':ReleaseDate', $releasedate);
                $statement->bindValue(':UploadDate', $uploaddate);
                $statement->bindValue(':Is_Video', $isvideo);
              
		$success = $statement->execute();
		$statement->closeCursor();

		if ($success) {
                    saveSongImageFile($trackID, $tempImageFilePath);
                    if ($deleteImage && $tempImageFilePath == "") {
				deleteSongImageFile($trackID);
			}
			return $statement->rowCount();         // Number of rows affected
		} else {
			logSQLError($statement->errorInfo());  // Log error to debug
		}		
	}