<!DOCTYPE html>
<!-- Admin Page -->
<html lang="en">
    <!-- Header PHP -->
    <?php
    $title = "Grading - Mysteria";
    include_once 'headerinclude.php';
    ?>
     
    <body >
        <!-- Set the div container to 'bggrad' -->
        <div class="bggrad">
            
        <!-- Navbar PHP-->
        <?php
        include_once 'navinclude.php';
        ?>
        
        <div>
        <!-- Create a table with the following border and CSS styling of the 'gradingtable' class -->
        
           <div id="wrapper">
        <table  id="gradingtable" >
       <tbody><tr> 
      <th>CIS 370 Assignment 4 Specific Requirements
      </th><th>How to test this feature.</th>
      <th>Works Completely<br>
        (Yes/No)</th>
    </tr>
    <tr> 
      <td>1.	Create an interface to add new data to your database. </td>
      <td>&nbsp; See Add Song tab under Admin Menu</td>
      <td>&nbsp; Yes</td>
    </tr>
    <tr>
      <td class="indent1">b. Provide appropriate HTML controls to input data
        including textboxes, selection boxes, radio buttons, checkboxes, calendar
      controls, etc.</td>
      <td>&nbsp;</td>
      <td>&nbsp; Yes</td>
    </tr>
    <tr> 
      <td class="indent2">i. Include at least one selection box on your input form.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
   <tr> 
      <td class="indent2">ii. Include at least one checkbox (or
      radio button) on your input form.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
   <tr> 
      <td class="indent2">iii. Include at least one date input (via text or date) on your input form.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent2">iv. Require at least one field as a minimum to make
      data valid.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent2">v.	Show a red * or other indication on form for required fields.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent1">c. Validate all data on the client-side and server
      side where appropriate.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent1">d. Make sure you can enter special characters such
        as single and double quotes, commas, ampersands, brackets, braces, and
      angle-brackets into text fields without causing errors.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent1">e. Dates should show and be entered in MM/DD/YYYY format
      but be stored in the database as date fields.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent1">f. After successful addition of a new entry, take them
      to the details-view form.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent1">g. If errors are found server-side, return them to
        the add screen with any entered data visible and a message to indicate
      all errors.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td>2.	Create an interface to edit data in your database.</td>
      <td>&nbsp;View song details page and hit edit button.</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent1">b. Try to share as much code as possible with your
      Add form.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td>3.	Provide an interface to delete data in your database.</td>
      <td>&nbsp;View song details page and hit delete button</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">b. Require the user to confirm the deletion and only
      delete if they confirm.</td>
      <td>&nbsp;</td>
      <td>&nbsp;No</td>
    </tr>
    <tr> 
      <td class="indent2">
        i. If they cancel the deletion, leave them on the display
          form.
      </td>
      <td>&nbsp;</td>
      <td>&nbsp;No</td>
    </tr>
    <tr> 
      <td>4.	Make your code portable:</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr> 
      <td class="indent1">a. Protect against Cross Site Scripting attacks (HTML
      injection).</td>
      <td>&nbsp;HTML will be filtered using htmlspecialchars</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">b. Your code should work with or without gpc_magic_quotes
      turned on.</td>
      <td>&nbsp;PDO used.</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">c. Use PHP Data Objects and parameterized queries to do all your updates to avoid SQL Injection attacks</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr> 
      <td>5.	Handle Adding, Changing, and Deleting your binary data.  </td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr> 
      <td class="indent1">a. When adding data to your database, include the ability to also add the binary data at the same time you add the structured data.</td>
      <td>&nbsp;Image adding supported on add song page.</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">b. When editing data, allow your binary data to be removed or changed.</td>
      <td>&nbsp;Image editing supported on edit song page.</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">c. When deleting data, make sure your binary data is deleted as well.</td>
      <td>&nbsp;Image automatically cleared when song is deleted.</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td colspan="3" bgcolor="#CCCCCC">
        <div align="center"><strong><font size="+1">Security Features</font></strong></div>
      </td>
    </tr>
    <tr>
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr> 
      <td>6. Integrate a security mechanism into your application that supports
      adding, changing, and deleting users, functions, and roles.</td>
      <td>&nbsp;Ran into issues with role management, could not assign
      functions. Security is partially complete, was unable to solve issue.</td>
      <td>&nbsp;No</td>
    </tr>
    <tr> 
      <td class="indent1">a. Adapt the format of the code provided to fit into
        your theme with your headers, footers, color schemes, and navigation
      system.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">b. Include a mechanism in your navigation system to
      support your security features.</td>
      <td>&nbsp;Security page link found in admin menu.</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr>
      <td class="indent2">i. Log In or Log Out should appear at the main menu
      level.</td>
      <td>&nbsp;</td>
      <td>&nbsp;No</td>
    </tr>
    <tr> 
      <td class="indent1">c. Set up users, functions, and roles appropriate for
      your application.</td>
      <td>&nbsp;</td>
      <td>&nbsp;No</td>
    </tr>
    <tr> 
      <td class="indent2">i.	Include an admin account with username “admin” and
      password “admin” with full access.</td>
      <td>&nbsp;Technically speaking, the admin account has fully access to all functions provided
      as we were unable to solve issues with roles and function assignment.</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent2">ii.	Include a read-only account with username of “reader” and
      password of “reader”.</td>
      <td>&nbsp;Similar explanation to above. </td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">d. Links for features that the current user does not
      have access to should either not show or be disabled (if it is a button). </td>
      <td>&nbsp;</td>
      <td>&nbsp;No</td>
    </tr>
    <tr>
      <td class="indent2">i.	This includes items in your navigation system.</td>
      <td>&nbsp;</td>
      <td>&nbsp;No</td>
    </tr>
    <tr> 
      <td class="indent2">ii. If a user attempts to go directly to a page (perhaps
        via a bookmark) and they are not currently logged in, and the page is
        not available to guests, bring up the login page in-line and then forward
      them on to their originally desired page.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr> 
      <td colspan="3" bgcolor="#CCCCCC"> <div align="center"><strong><font size="+1">Extra 
          Credit</font></strong></div></td>
    </tr>
    <tr> 
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr> 
      <td>7. Add a second table in your database to keep track of category-type information that you can use to feed into a selection box.    </td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
     <tr> 
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr> 
      <td colspan="3" bgcolor="#CCCCCC"> <div align="center"><strong><font size="+1">Turn In</font></strong></div></td>
    </tr>
    <tr> 
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
     <tr> 
      <td>8. This sheet linked in to your site under the Admin menu and filled 
        out properly so I can grade it.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td>9. Complete site published to vcisprod (including 
        redirection to this assignment).</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td class="indent1">a. Create a .zip file of your whole site and turn it in to the appropriate folder on D2L.</td>
      <td>&nbsp;</td>
      <td>&nbsp;Yes</td>
    </tr>
    <tr> 
      <td></td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
</tbody>
    </table> 
	</div>
        
        </div>
       
        <!-- Footer PHP -->
        <?php
        include_once 'footerinclude.php';
        ?>
        
        <script type="module" src="https://unpkg.com/ionicons@5.5.2/dist/ionicons/ionicons.esm.js"></script>
        <script nomodule src="https://unpkg.com/ionicons@5.5.2/dist/ionicons/ionicons.js"></script>
    </div>
    </body>
</html>
